Bug 351361 - (ghc-X11-extras) Review Request: ghc-X11-extras - Haskell X11-extras library
Review Request: ghc-X11-extras - Haskell X11-extras library
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-10-24 17:12 EDT by Till Maas
Modified: 2008-11-09 22:18 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-02-13 00:22:00 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Till Maas 2007-10-24 17:12:50 EDT
Spec URL: http://till.fedorapeople.org/review/X11-extras.spec
SRPM URL: http://till.fedorapeople.org/review/X11-extras-0.4-1.tillf7.src.rpm
Description:
Missing bindings to the X11 graphics library.
Comment 1 Patrice Dumas 2007-10-24 17:38:55 EDT
Shouldn't this be called haskell-X11-extras? The X11-extras is 
awfully badly chosen and too generic!
Comment 2 Till Maas 2007-10-24 17:50:38 EDT
(In reply to comment #1)
> Shouldn't this be called haskell-X11-extras? The X11-extras is 
> awfully badly chosen and too generic!

Maybe, but the packages this spec produces use ghc prefixes, so this may be only
a problem in CVS, but when the there is a guideline for naming Haskell
libraries, then this can be changed without the need of a rebuild. Using haskell
as prefix for the packages is not good, because there are different incompatible
haskell compilers. Using ghc-X11-extras for the spec may be a solution, but then
in case it should contain also other subpackages for other compilers, it would
not be good. If you demand a specific name for this package to finish review,
then I would prefer to rename it to ghc-X11-extras.
Comment 3 Patrice Dumas 2007-10-24 17:57:58 EDT
I proposed that name for consistency with perl or python,
but I don't have the slightest idea about what is haskell.
I can, however, see when a package has a generic naming 
although it is a binding...
Comment 4 Till Maas 2007-10-24 18:22:22 EDT
Here is a spec with the ghc prefix. This spec also uses %ghost in %files instead
of rm in %preun

Spec URL: http://till.fedorapeople.org/review/ghc-X11-extras.spec
SRPM URL: http://till.fedorapeople.org/review/ghc-X11-extras-0.4-2.tillf7.src.rpm

Thinking about it a little more, this is my favourite naming. I hope that
someone from the Haskell Sig noticed this review request (I added it to their
wiki page), but I will cc them, if it seems, that it is needed. Maybe there will
be some Haskell Guidelines, when the review of this package is finished.
Comment 5 Jens Petersen 2007-11-02 02:48:31 EDT
Thanks for submitting X11-extras. :)  I had been wanting to have in
Fedora for a while.

I Agree the ghc prefix makes sense here.

Currently we don't have any other Haskell compilers in Fedora,
though we do have hugs98 (an interpreter) and there could be
libraries packaged for it too.

The first library we have (had for a while) is gtk2hs for ghc,
but I expect there will surely be more coming.
Yes, we need packaging guidelines for Haskell, and I'd
like to see this review as a rehearsal to make a draft for that. :)
Comment 6 Michel Alexandre Salim 2007-11-13 02:54:32 EST
Build fails for me with the following:

+ runhaskell Setup.lhs copy
--destdir=/home/builder/packages/tmp/ghc-X11-extras-0.4-2.fc8-root-builder
Installing:
/home/builder/packages/tmp/ghc-X11-extras-0.4-2.fc8-root-builder/usr/lib64/X11-extras-0.4/ghc-6.8.1
+ install .installed-pkg-config
/home/builder/packages/tmp/ghc-X11-extras-0.4-2.fc8-root-builder/usr/lib64/X11-extras-0.4/ghc-6.8.1/X11-extras.pkg
install: cannot stat `.installed-pkg-config': No such file or directory
erreur: Mauvais status de sortie pour /home/builder/packages/tmp/rpm-tmp.2795
(%install)
Comment 7 Till Maas 2007-11-13 03:53:24 EST
Spec URL: http://till.fedorapeople.org/review/ghc-X11-extras.spec
SRPM URL: http://till.fedorapeople.org/review/ghc-X11-extras-0.4-3.tillf7.src.rpm

Here is a new spec that builds on koji:

http://koji.fedoraproject.org/koji/taskinfo?taskID=239095
http://koji.fedoraproject.org/koji/taskinfo?taskID=239091

I needed to change the way %ghcver was defined because otherwise koji complained
about a multiple define package, because it tested %description before the BRs
were fulfilled.


(In reply to comment #6)
> Build fails for me with the following:
> 
> + runhaskell Setup.lhs copy
> --destdir=/home/builder/packages/tmp/ghc-X11-extras-0.4-2.fc8-root-builder
> Installing:
>
/home/builder/packages/tmp/ghc-X11-extras-0.4-2.fc8-root-builder/usr/lib64/X11-extras-0.4/ghc-6.8.1
> + install .installed-pkg-config
>
/home/builder/packages/tmp/ghc-X11-extras-0.4-2.fc8-root-builder/usr/lib64/X11-extras-0.4/ghc-6.8.1/X11-extras.pkg
> install: cannot stat `.installed-pkg-config': No such file or directory
> erreur: Mauvais status de sortie pour /home/builder/packages/tmp/rpm-tmp.2795
> (%install)

How did you build it? I do not know, why .installed-pkg-config is not there. Is
it maybe somewhere else or is there a similiar file in the source directory?
Comment 8 Michel Alexandre Salim 2007-11-15 13:50:38 EST
Using ghc-6.8.1 from updates-testing, just with rpmbuild.

Something is broken with the way RPM parses macros, by the way, and it's
happening here: your commented-out #%define ghc_version in line 2 actually
shadows the automatic detection in line 1 (occured to me in the past when trying
to comment out %configure in other packages)

Deleting line 2 (or just deleting the %) lets the build proceed, but fails the
same way as before -- .installed-pkg-config not found.
Comment 9 Till Maas 2007-11-26 18:44:14 EST
Spec URL: http://till.fedorapeople.org/review/ghc-X11-extras.spec
SRPM URL: http://till.fedorapeople.org/review/ghc-X11-extras-0.4-4.tillf7.src.rpm

Here is a new spec that builds on koji:

F8:
http://koji.fedoraproject.org/koji/taskinfo?taskID=259984
F9:
http://koji.fedoraproject.org/koji/taskinfo?taskID=259983

The installed-pkg-config is at a different location when using the newer version
of ghc (or cabal)
Comment 10 Hans Ulrich Niedermann 2007-12-12 04:06:51 EST
Running rpmlint on the packages built from ghc-X11-extras-0.4-4.tillf7.src.rpm:

ghc681-X11-extras.i386: W: devel-file-in-non-devel-package
/usr/lib/X11-extras-0.4/ghc-6.8.1/libHSX11-extras-0.4.a
ghc681-X11-extras.i386: E: script-without-shebang
/usr/lib/X11-extras-0.4/ghc-6.8.1/X11-extras.pkg
ghc681-X11-extras.i386: W: devel-file-in-non-devel-package
/usr/lib/X11-extras-0.4/ghc-6.8.1/include/XlibExtras.h
ghc-X11-extras.i386: W: no-documentation
ghc-X11-extras.i386: E: no-binary
Comment 11 Till Maas 2007-12-12 05:53:53 EST
(In reply to comment #10)

> ghc681-X11-extras.i386: W: devel-file-in-non-devel-package
> /usr/lib/X11-extras-0.4/ghc-6.8.1/libHSX11-extras-0.4.a

The complete package is a haskell devel package afaik.

> ghc681-X11-extras.i386: E: script-without-shebang
> /usr/lib/X11-extras-0.4/ghc-6.8.1/X11-extras.pkg

Is this file executable? I will check this later.

> ghc681-X11-extras.i386: W: devel-file-in-non-devel-package
> /usr/lib/X11-extras-0.4/ghc-6.8.1/include/XlibExtras.h

see above.

> ghc-X11-extras.i386: W: no-documentation
> ghc-X11-extras.i386: E: no-binary

This is also intended, because the package is only there to make it easier to
get the latest package.

Nevertheless, it seem that ghc-X11-extras is not needed anymore, at least the
latest release of xmonad does not need it, but a newer version of "ghc-X11", but
I need to do some more research here - or does someone else know more about this?
Comment 12 Jens Petersen 2008-02-06 19:14:16 EST
Sorry for neglecting this review too long...

(In reply to comment #11)
> Nevertheless, it seem that ghc-X11-extras is not needed anymore, at least the
> latest release of xmonad does not need it, but a newer version of "ghc-X11",
> but I need to do some more research here

Right I just noticed this myself.

I didn't search the haskell mailing-lists but I see:
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=464004

I think it would be good and straightforward to update your package to X11
instead since ghc-6.8.2 no longer seems to ship X11.
Comment 13 Jens Petersen 2008-02-12 23:31:49 EST
Ah nevermind I see ghc-X11 in bug 426751.

So I think this bug can be closed.

Note You need to log in before you can comment on or make changes to this bug.